#-----------------------------------------------------------------------
# initiate:   systemctl enable aehostd-ph.service
# start:      systemctl start aehostd-ph.service
# get status: systemctl status aehostd-ph.service
#
# {{ ansible_managed }}
#-----------------------------------------------------------------------

[Unit]
Description=Privileged helper service for AE-DIR
Documentation=https://ae-dir.com/aehostd.html
Requires=local-fs.target
After=local-fs.target

[Service]
Type=simple
PIDFile={{ aehostd_pid_file|dirname }}/aehostd-ph.pid
User=root
Group=root
# let Python use random object identifier
Environment=PYTHONHASHSEED=random
# full optimization (especially __debug__ = False)
Environment=PYTHONOPTIMIZE=2
# avoid to accidentially write Python byte code
Environment=PYTHONDONTWRITEBYTECODE=1
Environment=PYTHONWARNINGS=error
ExecStart={{ aehostd_python }} -m aehostd.priv --no-fork --pid {{ aehostd_pid_file|dirname }}/aehostd-ph.pid --config {{ aehostd_conf_file }}
Restart=always
StandardError=syslog
UMask=027
# various hardening options
CapabilityBoundingSet=CAP_DAC_OVERRIDE CAP_FOWNER CAP_CHOWN
AmbientCapabilities=CAP_DAC_OVERRIDE CAP_FOWNER CAP_CHOWN
PrivateTmp=yes
PrivateDevices=yes
DevicePolicy=closed
DeviceAllow=/dev/log w
PrivateNetwork=yes
IPAddressDeny=any
ProtectSystem=yes
ProtectHome=yes
ProtectKernelModules=yes
ProtectKernelTunables=yes
ProtectKernelLogs=yes
ProtectControlGroups=yes
ProtectHostname=yes
ProtectClock=yes
NoNewPrivileges=yes
MountFlags=private
LockPersonality=yes
RestrictRealtime=yes
RestrictNamespaces=yes
RestrictSUIDSGID=yes
KeyringMode=private
MemoryDenyWriteExecute=yes
RemoveIPC=yes
SystemCallArchitectures=native
SystemCallFilter=~ madvise @clock @cpu-emulation @debug @keyring @module @mount @raw-io @reboot @swap @obsolete @timer @resources @privileged @pkey @obsolete @setuid
SystemCallFilter=@chown
RestrictAddressFamilies=AF_UNIX

{% if aehostd_apparmor_enabled %}
#AppArmorProfile=aehostd-ph
{% endif %}

[Install]
WantedBy=multi-user.target
